import ZSI.TC
from pyGridWare.generated.types.Counter_services_types import *
from pyGridWare.addressing.AddressingUtils import AddressingUtils
from pyGridWare.resource.ResourceHome import PersistentResourceHome
from pyGridWare.properties.ResourceProperties import ResourceProperties


class CounterKey(int):
    typecode = ZSI.TC.Iint(pname=("http://counter.com",'CounterKey'))

class Value(int):
    typecode = counter_com.Value_Dec()

    def getNamespaceURI(self):
        return typecode.nspname

    def getElementName(self):
        return typecode.pname


class CounterProperties(ResourceProperties):
    property_class = counter_com.CounterRP_Dec

    def __init__(self):
        self._element = CounterProperties.property_class()
        self._element._Value = Value(0)

    def getValue(self):
        return self._element._Value

    def setValue(self, value):
        self._element._Value = Value(value)

    def getResourceProperty(self, namespaceURI, localName):
        '''Resource must be a global element declaration, 
        and so assume that it is either the ResourceProperty
        element itself, or one of the element references in
        its model group.
        '''
        what = self._element
        if what.nspname == namespaceURI and  what.pname == localName:
            return what
        elif hasattr(what, 'ofwhat'):
            for what in what.ofwhat:
                if what.nspname == namespaceURI and  what.pname == localName:
                    return getattr(self._element, what.aname, None)
        raise NoResourceProperty, \
            "getResourceProperty failed to locate (%s,%s)" %(namespaceURI,localName)

