from pyGridWare.resource.ResourceSweeper import ResourceSweeper


class UnknownResourceError(Exception): pass

class SimpleResourceHome:
    def __init__(self):
       self.resources = {}

    def create(self, ctx, key):
       self.resources[key] = ctx

    def get(self, key):
       if not self.resources.has_key(key):
           raise UnknownResourceError, 'no context id(%s) in home %s' %(key,self.resources.keys())
       return self.resources[key]


class PersistentResourceHome:
    resourceID = 1000

    def __init__(self): 
        self.resources = {}
        self.sweeper = ResourceSweeper(self, 5.0)

    def add(self, ctx, key):
        self.resources[str(key)] = ctx

    def create(self):
        key = PersistentResourceHome.resourceID 
        PersistentResourceHome.resourceID += 1
        return key

    def setTerminationTime(self, key, terminationTime=None):
        if terminationTime is None:
            del self.resources[str(key)]
        else:
            self.resources[str(key)].setTerminationTime(terminationTime)

    def get(self, key):
        if self.resources.has_key(str(key)) is False:
          raise UnknownResourceError, 'No Resource for ResourceID %s' %str(key)
        return self.resources[str(key)]

    def getSweeperDelay(self):
        return self.sweeper.getSweeperDelay()

    def setSweeperDelay(self, delay):
        self.sweeper.setSweeperDelay(delay)

    def getResources(self):
        return self.resources.values()
